#This script set is a part of iVikodak. If you use it, kindly cite iVikodak (Citation information available at https://web.rniapps.net/iVikodak/).
library(Cairo)
x11 = function (...) grDevices::x11(...,type='cairo')
args = commandArgs(trailingOnly=TRUE)
d<-read.table(args[1],header=FALSE)
outname<-paste("boxplot",args[2],"png",sep=".")
outname2<-paste("boxplot.faceted",args[2],"png",sep=".")
library(ggplot2)
require(grid)
yaxti=args[7]


Cairo(file = outname, width = as.numeric(args[3]), height = as.numeric(args[4]), bg = "white", units = 'in',res = 300, type="png")
ggplot(d, aes(x=reorder(V1, V2), y=V2))+geom_boxplot(aes(fill=V3),width=0.3,alpha=1,outlier.colour="grey",outlier.size=2,position=position_dodge(0.5)) +  theme_bw() + theme(     plot.background=element_blank()    ,panel.grid.major = element_blank()    ,panel.grid.minor = element_blank() )  + theme(strip.text.x = element_text(colour = "black", size = 12)) +theme(axis.text.x = element_text(size=7,angle = 90, hjust = 1)) +scale_fill_discrete(breaks = unique(d$V3)) + theme(panel.border=element_rect(color = "8", fill = NA, size = 1)) + theme(panel.margin = unit(0, "lines"))+ theme(strip.background = element_rect(colour = "white", fill = "8", size = 0.5),axis.title.x=element_blank()) + scale_y_continuous(name=yaxti)+ theme(legend.title=element_blank()) +theme(legend.position="bottom")+ theme(legend.text=element_text(size=15))


dev.off()
Cairo(file = outname2, width = as.numeric(args[5]), height = as.numeric(args[6]), bg = "white", units = 'in',res = 300,type="png")
ggplot(d, aes(x=V1,y=V2)) + geom_boxplot(aes(fill=V3),alpha=1,outlier.colour="grey",outlier.size=1,position=position_dodge(1)) +  theme_bw() + theme(     plot.background=element_blank()    ,panel.grid.major = element_blank()    ,panel.grid.minor = element_blank() ) + theme(axis.ticks.x=element_blank(),axis.text.x=element_blank())+ facet_wrap( ~ V1,scales="free") + theme(strip.text.x = element_text(colour = "black", size = 7)) + scale_fill_discrete(breaks = unique(d$V3)) + theme(panel.border=element_rect(color = "8", fill = NA, size = 1)) + theme(axis.title.x=element_blank()) + theme(panel.margin = unit(1, "lines"))+ theme(strip.background = element_rect(colour = "white", fill = "8", size = 0.5),axis.title.x=element_blank()) + scale_y_continuous(name=yaxti) + theme(legend.title=element_blank()) + theme(legend.position="bottom")+ theme(legend.text=element_text(size=15))


dev.off()

