#This script set is a part of iVikodak. If you use it, kindly cite iVikodak (Citation information available at https://web.rniapps.net/iVikodak/). Copyright @ TCS, 2018 
if [ $# -ne 7 ]
then
echo "Usage: sh iVikographics.sh filename codetype w1 h1 w2 h2 yaxt\n\nExample: sh iVikographics.sh Sample.txt box 10 8 10 8 Abundance"
else
filename="$1" #Tab separated input file with two headers: First header of classNames and second header of sampleNames
codetype="$2" #Graph type, options: box, boxedit, indibar, groupbar, wave
w1="$3" #Width for unified layout
h1="$4" #Height for Unified layout
w2="$5" #Width for facet layout
h2="$6" #Height for facet layout
yaxt="$7" #Y Axis title. Don't use spaces. 

mkdir $1.Temp
awk -F "\t" '{if(NR==1 || NR==2) print "Median\t"$0; else {for(i=2;i<=NF;i++) array[i]=$i;asort(array);if((NF-1)%2!=0) med=array[NF/2];else med=(array[(NF-1)/2]+array[((NF-1)/2 )+1])/2;print med"\t"$0} delete array}' $1 > $filename.Temp/with_median #Medians being printed in first column of the input data

sed '1d' $filename.Temp/with_median | sed '1d' | sort -nrk1,1 | cut -f2- > $filename.Temp/remaining #Sorting Features by Median
head -2 $filename.Temp/with_median | cut -f2- | cat - $filename.Temp/remaining > $filename.Temp/filenew 
awk '{for(i=1; i<=NF; i++){a[NR,i] = $i}}NF>p { p = NF }END {for(j=1; j<=p; j++) {str=a[1,j];for(i=2; i<=NR; i++){str=str"\t"a[i,j];}print str}}' $filename.Temp/filenew > $filename.Temp/Classes

head -1 $filename.Temp/Classes > $filename.Temp/l1
for class in `cut -f1 $filename.Temp/Classes | sed '1d' | sed '1d' | sort | uniq`
do
	grep -w $class $filename.Temp/Classes
done >> $filename.Temp/l1

#---------Formatting for ggplot input--------------#
awk '{for(i=1; i<=NF; i++){a[NR,i] = $i}}NF>p { p = NF }END {for(j=1; j<=p; j++) {str=a[1,j];for(i=2; i<=NR; i++){str=str"\t"a[i,j];}print str}}' $filename.Temp/l1 > $filename.Temp/inputfile

awk -F "\t" '{if(NR>2) {for(i=2;i<=NF;i++) print $1"\t"$i}}' $filename.Temp/inputfile > $filename.Temp/a
awk -F "\t" '{if(NR==1) for(i=2;i<=NF;i++) array[i]=$i}END{for(j=3;j<=NR;j++) {for(k=2;k<=i-1;k++) print array[k]}}' $filename.Temp/inputfile > $filename.Temp/b
awk -F "\t" '{if(NR==2) for(i=2;i<=NF;i++) array[i]=$i}END{for(j=3;j<=NR;j++) {for(k=2;k<=i-1;k++) print array[k]}}' $filename.Temp/inputfile > $filename.Temp/c

paste $filename.Temp/a $filename.Temp/b $filename.Temp/c > $filename.Temp/$filename

rm $filename.Temp/a $filename.Temp/b $filename.Temp/c

#-----------------------GGPLOT CALL----------------#
if [ $codetype = "box" ]
then
Rscript box.r $filename.Temp/$filename $filename $w1 $h1 $w2 $h2 $yaxt
else
Rscript barindi.r $filename.Temp/$filename $filename $w1 $h1 $w2 $h2
fi
rm -rf $filename.Temp/
fi

